[KompoZer 0.8] Portage de KompoZer sous Gecko 1.8.1

Le premier forum francophone sur l'éditeur de pages Web multiplateforme (Linux, Mac OS X, Windows) qui monte… KompoZer, héritier de Nvu, permet de créer vos pages Web graphiquement (wysiwyg) sans aucune connaissance du langage HTML.

Modérateur : chinon37

Kazé
Varan
Messages : 1743
Inscription : 10 févr. 2005, 10:26

[KompoZer 0.8] Portage de KompoZer sous Gecko 1.8.1

Message par Kazé »

  • Ce sujet est parti de la discussion sur les plantages de KompoZer sous les distributions Linux récentes (utilisant GTK 2.14), une solution envisagée étant de porter KompoZer sous Gecko 1.8.1 (= Firefox 2). Pour rappel, Nvu 1.0 et KompoZer 0.7.x sont basés sur Gecko 1.7 (= Firefox 1).
    Chinon a proposé d'ouvrir un nouveau topic pour faire état de l'avancement des travaux sur KompoZer, parler de la suppression de l'onglet source, de l'intégration de Firebug et autres joyeusetés. ;-)
    Merci de poster ici pour tout ce qui concerne l'évolution de KpZ. Attention, tout ceci n'est pour l'instant qu'un travail en cours, sans aucune garantie de résultat pour les utilisateurs.
  • Mise à jour :
    KompoZer 0.8 prend bonne tournure, l’essentiel des fonctionnalités a été récupéré, et des versions de test sont proposées :Avant de les installer vous devrez supprimer ou renommer votre profil KompoZer 0.7.x.
    Attention, ces versions sont encore au stade « alpha » : à n’utiliser que pour participer au débug !
Tant qu'à patcher KompoZer, je me demande si je n'aurais pas meilleur compte à le porter sous une version plus récente du tronc Mozilla. Comme ça fait deux jours que je m'acharne sur la question, je ne résiste pas à l'envie de vous montrer ça :
  • Image
Ce n'est que la toute première compilation réussie de KompoZer sous Mozilla 1.8.x (obtenue il y a dix minutes à peine), il manque encore beaucoup de choses, donc ne nous emballons pas. Mais si ça voulait bien fonctionner correctement, ça devrait assurer la survie de KompoZer jusqu'à l'avènement de BlueGriffon, voire au-delà. En un mot comme en cent, ça ferait une version 0.8 qui aurait de la gueule.

C'est complètement exagéré par rapport au besoin (= corriger KpZ pour les distros récentes), mais les mainteneurs des paquets Linux me mettent la pression pour porter KompoZer sur un noyau Mozilla récent. Et accessoirement, c'est l'occasion pour moi de refaire tout le gestionnaire de site.

Si je n'y arrive pas, je me contenterai de fournir des patches aux différentes distributions. :?
Dernière modification par Kazé le 13 févr. 2009, 19:07, modifié 4 fois.
KompoZer lead dev
Ubuntu 10.04 Lucid Lynx — « L'erreur est humaine, mais vraiment foutre la merde nécessite le mot de passe root. »
chinon37
Animal mythique
Messages : 5318
Inscription : 21 mars 2005, 10:17

Message par chinon37 »

Kaze a écrit :Tant qu'à patcher KompoZer, je me demande si je n'aurais pas meilleur compte à le porter sous une version plus récente du tronc Mozilla.
Surtout, ne t'en prive pas! :D
On est prêts pour les tests :wink: :D
Mais si ça voulait bien fonctionner correctement, ça devrait assurer la survie de KompoZer jusqu'à l'avènement de BlueGriffon, voire au-delà.
ça nous laisse un peu de temps...
Préferez Kompozer 0.8 à Nvu
Défendons nos valeurs, adhérons à l'APRIL
La Démocratie, c'est quand on frappe à votre porte à 6h00 du matin, et que c'est le laitier.
albion
Gecko
Messages : 77
Inscription : 08 févr. 2008, 20:32

Message par albion »

Kaze a écrit :Tant qu'à patcher KompoZer, je me demande si je n'aurais pas meilleur compte à le porter sous une version plus récente du tronc Mozilla.
Ça serait super ! Et puis ça serait l'occasion de supprimer l'appellation "bug-fix release"
Kazé
Varan
Messages : 1743
Inscription : 10 févr. 2005, 10:26

Message par Kazé »

albion a écrit :
Kaze a écrit :Tant qu'à patcher KompoZer, je me demande si je n'aurais pas meilleur compte à le porter sous une version plus récente du tronc Mozilla.
Ça serait super ! Et puis ça serait l'occasion de supprimer l'appellation "bug-fix release"
Oui, « bug-adding release » sonnerait mieux ! :twisted:
Le portage de KompoZer sous Mozilla 1.8 ou 1.9 serait profitable à long terme, mais ça va ajouter des bugs à court terme. On verra bien...
roandjepa a écrit :Dès que je vai dans un sous-menu, Kompozer se ferme. :evil:
Oui, j'ai vu qu'il y a un problème avec xblPopupShowing(). Dans le pire des cas, ça sera résolu avec un petit patch.
KompoZer lead dev
Ubuntu 10.04 Lucid Lynx — « L'erreur est humaine, mais vraiment foutre la merde nécessite le mot de passe root. »
chinon37
Animal mythique
Messages : 5318
Inscription : 21 mars 2005, 10:17

Message par chinon37 »

Kaze a écrit : Le portage de KompoZer sous Mozilla 1.8 ou 1.9 serait profitable à long terme, mais ça va ajouter des bugs à court terme. On verra bien...
Ben sinon, à quoi on servirait? :roll: :)
Préferez Kompozer 0.8 à Nvu
Défendons nos valeurs, adhérons à l'APRIL
La Démocratie, c'est quand on frappe à votre porte à 6h00 du matin, et que c'est le laitier.
Kazé
Varan
Messages : 1743
Inscription : 10 févr. 2005, 10:26

Message par Kazé »

J'ai enfin pris le temps de tester une distro récente, en l'occurrence Ubuntu 8.10. Au passage, j'ai pris la version Gnome par erreur (Xfce rulez), et j'ai été *très* agréablement surpris des progrès de cet environnement de bureau ! Tout a été pensé pour ne pas em****er l'utilisateur, c'est super propre.
Je confirme que Nvu / KompoZer crashe dès qu'on cherche à afficher un sous-menu. Je n'ai pas vraiment cherché pourquoi, je présume que la base Mozilla 1.7 est compatible GTK 2.12 mais pas avec GTK 2.14. (note pour moi-même : penser à mettre cette limite dans les paquets KompoZer 0.7.x)

Le portage de KompoZer sous Mozilla 1.8.1 se poursuit (= Firefox 2). J'ai terminé 90% du boulot sur les chromes, tous les menus sont fonctionnels ou presque, et accessoirement, on peut afficher des sous-menus sans crasher KompoZer. Il reste maintenant à patcher le noyau pour finir le portage...
J'ai jeté un oeil à Mozilla 1.9 (= Firefox 3), mais cette branche m'imposerait trop de boulot, et si BlueGriffon aboutit ça ne servirait à rien. Par ailleurs, la branche 1.8 me suffira pour l'objectif principal, qui serait, outre la compatibilité GTK 2.14, de rendre KompoZer compatible avec des extensions comme Firebug, FireFTP, l'Inspecteur DOM, etc.

Voilà ce qu'il reste à faire coté noyau :
  1. support xhtml / css / php (note pour moi-même : penser à regarder pour le support des balises <% %>).
  2. coloration syntaxique de l'onglet "source" (beurk)
  3. templates (beurk aussi)
  4. gestionnaire de site : soit je patche l'horreur qui sert de gestionnaire de sites à Nvu/KpZ, soit j'en refais un autre 100% xul en pompant honteusement sur FireFTP par exemple.
  5. correcteur orthographique : pas encore regardé, aucune idée du temps nécessaire pour le portage.
Si ça se passe bien, on aura la première 'alpha' fin de semaine prochaine, sans gestionnaire de sites ni correcteur orthographique. En gros ça serait un SeaMonkey Composer avec des onglets et du support xhtml / css / php.
Aucune idée du temps qu'il me faudra pour patcher *tout* le noyau. J'espère que je ne m'embarque pas dans une galère, on verra bien.

PS: je ne suis pas sûr de vouloir garder l'onglet source, pour plusieurs raisons :
  • il plante
  • il est moche (pas de coloration syntaxique temps réel)
  • il contribue à pourrir le code html
  • il est beaucoup moins pratique que Firebug
Si vous voyez une bonne raison de garder cet onglet "source", merci de m'en faire part. :wink:
KompoZer lead dev
Ubuntu 10.04 Lucid Lynx — « L'erreur est humaine, mais vraiment foutre la merde nécessite le mot de passe root. »
astre

source

Message par astre »

Kaze a écrit : Je ne suis pas sûr de vouloir garder l'onglet source, pour plusieurs raisons :
  • il plante
  • il est moche (pas de coloration syntaxique temps réel)
  • il contribue à pourrir le code html
  • il est beaucoup moins pratique que Firebug
Si vous voyez une bonne raison de garder cet onglet "source", merci de m'en faire part. :wink:
Bonjour. Moi, sous Hardy, je l'utilisais cet onglet "source". C'est bien pratique pour corriger des erreurs [quand j'étais sous Windows, je faisais mon site avec "Claris Home page", un programme (offert avec wanadoo) qui m'a donné satisfaction sous Windows 95, sous XP mais qui a du mal sous Vista. Maintenant que je suis passé à Ubuntu, il faut parfois que j'adapte en mode source des trucs qui ne se font plus dans le même ordre sous KompoZer.
Je ne domine pas le sujet, mais par essais-erreurs, j'y arrive !
Voilà. Merci pour tout ce que vous faites !
Michel Astre. Poèmes et chansons pour les cinq saisons
www.astre.fr.st

Message envoyé avec : Mozilla/5.0 (X11; U; Linux i686; fr; rv:1.9.0.3) Gecko/2008101315 Ubuntu/8.10 (intrepid) Firefox/3.0.3
Ymai
Tyrannosaurus Rex
Messages : 4220
Inscription : 12 mars 2005, 11:36

Re: source

Message par Ymai »

Bonjour
astre a écrit :Bonjour. Moi, sous Hardy, je l'utilisais cet onglet "source". C'est bien pratique pour corriger des erreurs
Il y a au moins trois façons de s'en sortir autrement:
1. Utiliser KompoZer et profiter du fait qu'il produit du code propre et sans erreurs :D
2. sélectionner la partie du texte à corriger dans l'onglet Normal et passer par > Insertion > Code HTML
3. utiliser Handcoder et un vrai éditeur externe avec coloration syntaxique et autocomplétion HTML, PHP, Javascript et tout le toutim.

Tant pis pour l'aspect didactique de l'onglet "Source" qui permet de voir le code à tout instant. C'est bien utile, mais si cela stabilise le logiciel, il n'y a pas de question.

Message envoyé avec : Mozilla/5.0 (X11; U; Linux i686; fr; rv:1.9.0.3) Gecko/2008092510 Ubuntu/8.04 (hardy) Firefox/3.0.3
ymai
« Un enfant de cinq ans comprendrait cela ! Allez me chercher un enfant de cinq ans ! »
Groucho Marx.
Ymai
Tyrannosaurus Rex
Messages : 4220
Inscription : 12 mars 2005, 11:36

Message par Ymai »

Kaze a écrit :et si BlueGriffon aboutit ça
stay tuned...

Message envoyé avec : Mozilla/5.0 (X11; U; Linux i686; fr; rv:1.9.0.3) Gecko/2008092510 Ubuntu/8.04 (hardy) Firefox/3.0.3
ymai
« Un enfant de cinq ans comprendrait cela ! Allez me chercher un enfant de cinq ans ! »
Groucho Marx.
Kazé
Varan
Messages : 1743
Inscription : 10 févr. 2005, 10:26

Re: source

Message par Kazé »

Merci pour vos avis.
J'avoue que malgré tout le mal que je pense de cet onglet "source", je rechigne à le supprimer. M'enfin pour l'instant il ne fonctionne pas du tout sur ma version de travail.
Ymai a écrit :Tant pis pour l'aspect didactique de l'onglet "Source" qui permet de voir le code à tout instant. C'est bien utile, mais si cela stabilise le logiciel, il n'y a pas de question.
Justement, l'idée serait de remplacer cet onglet "Source" par Firebug. On pourrait ainsi voir le code HTML s'écrire au fur et à mesure, en bas de la fenêtre KompoZer ; et quand on sélectionne une ligne de code dans Firebug, ça sélectionnerait la partie correspondante dans la fenêtre wysiwyg.

Par ailleurs, avec Firebug il est impossible d'écrire du code HTML "corrompu" - i.e. en oubliant des tags, des "/>", des guillemets pour les attributs, etc. - alors que quand on écrit du code corrompu avec l'onglet "source", dans le meilleur des cas on pourrit son document HTML (la faute à KompoZer qui doit reconstruire l'arbre DOM en se basant sur du code HTML erronné), dans le pire on crashe KompoZer.

Bref, je pense qu'il rendrait les mêmes services que l'onglet "source". Accessoirement, cette extension est activement développée et rencontre un franc succès chez les webmestres « à l'ancienne » (= Firefox + éditeur texte). Et par ailleurs, il est probable que ça me prenne moins de temps à adapter Firebug à KompoZer plutôt que d'essayer de récupérer l'onglet "source".

De plus, je voudrais profiter de mon boulot actuel sur KompoZer pour le débarrasser de tous les composants qui ont été implémentés à la truelle (Nvu/KpZ repose sur un vieux noyau avec 15 000 lignes de patches non documentées) et qui le pénalisent en termes de stabilité et de pérennité.
L'exemple-type de ce genre de bricolage qui apporte plus de problèmes que de solutions, c'est l'onglet "source" de Nvu/KompoZer. Tentative d'expication, pour finir d'assommer tout le monde :
  • Dans Netscape/SeaMonkey Composer, l'onglet "source" est un vrai éditeur texte.
    Pas de coloration syntaxique, mais pas de plantage non plus (ou si peu).
  • Dans Nvu/KompoZer, l'onglet "source" est un éditeur HTML.
    On édite en wysiwyg le code "viewsource" (= le code mis en couleur quand on fait un Ctrl+U sous Firefox). Donc non seulement la coloration syntaxique n'est pas temps réel, mais en plus on édite un document HTML qui représente le code source, et au moment de revenir en vue "normale", on convertit ce document HTML en texte puis on reconstruit l'arbre DOM à partir du texte obtenu.
En résumé, pour modifier le code HTML avec cet onglet source, ça donne :
  1. création du document "viewsource" à partir du DOM du document HTML courant
  2. édition du document "viewsource" avec un éditeur HTML wysiwyg
  3. conversion du document "viewsource" ainsi modifié en texte brut
  4. régénération du DOM du document HTML à partir du texte brut obtenu
Après, on s'étonne que ça plante... moi, ce qui m'étonne, c'est que ça puisse fonctionner.

Firebug, lui, assure une vraie coloration syntaxique, et ne modifie que l'élément HTML en cours d'édition. On travaille directement sur l'arbre DOM du document courant, on ne fait jamais de conversion texte <-> html. Non seulement c'est plus respectueux de l'architecture logicielle de Nvu/KpZ, mais surtout on ne risque donc pas de corrompre tout le document juste parce qu'on a voulu ajouter un attribut HTML à la main.

Pour l'instant je n'ai rien décidé, peut-être que je ferai les deux (onglet source + firebug), ou peut-être que je n'arriverai pas à finir le portage de KompoZer. Je ne fais que prendre des avis. ;-)
Dernière modification par Kazé le 17 nov. 2008, 11:56, modifié 1 fois.
KompoZer lead dev
Ubuntu 10.04 Lucid Lynx — « L'erreur est humaine, mais vraiment foutre la merde nécessite le mot de passe root. »
albion
Gecko
Messages : 77
Inscription : 08 févr. 2008, 20:32

Message par albion »

Effectivement si on peut voir/explorer/éditer le code source avec firebug, je vois mal l'intérêt de garder l'onglet source :?
Justement, l'idée serait de remplacer cet onglet "Source" par Firebug. On pourrait ainsi voir le code HTML s'écrire au fur et à mesure, en bas de la fenêtre KompoZer ; et quand on sélectionne une ligne de code dans Firebug, ça sélectionnerait la partie correspondante dans la fenêtre wysiwyg
ça serait vraiment excellent, si pratique ! Je plussoie vivement ce remplacement :D

Message envoyé avec : Mozilla/5.0 (X11; U; Linux i686; fr; rv:1.9.0.3) Gecko/2008092416 Firefox/3.0.3
chinon37
Animal mythique
Messages : 5318
Inscription : 21 mars 2005, 10:17

Message par chinon37 »

pendant les 15 secondes que j'ai devant moi, je donne mon avis qui n'a pas changé depuis 2 ans: que l'on passe avec un éditeur texte comme c'est le cas avec Handcoder ou par Firebug, je suis pour la suppression de l'onglet source. Si en plus cela simplifie le travail de Kaze...
Préferez Kompozer 0.8 à Nvu
Défendons nos valeurs, adhérons à l'APRIL
La Démocratie, c'est quand on frappe à votre porte à 6h00 du matin, et que c'est le laitier.
GAUNCE
Iguane
Messages : 643
Inscription : 19 déc. 2004, 00:48

Message par GAUNCE »

Màs uno!

Message envoyé avec : Mozilla/5.0 (Windows; U; Windows NT 5.1; fr; rv:1.9.0.4) Gecko/2008102920 Firefox/3.0.4
Ma configuration
Si tu es dans l'obscurité, viens sur ce forum pour t'éclairer (proverbe Landais)
" La libertat qu'ei lo camin "
Kazé
Varan
Messages : 1743
Inscription : 10 févr. 2005, 10:26

Message par Kazé »

Ça avance doucement, j'ai enfin récupéré le support XHTML.
  • Image
Prochaine étape, support PHP et CSS.
Dès que j'aurai récupéré le XHTML, le PHP et le CSS, je proposerai aux Linuxiens une alpha bien farcie de bugs. :wink:
KompoZer lead dev
Ubuntu 10.04 Lucid Lynx — « L'erreur est humaine, mais vraiment foutre la merde nécessite le mot de passe root. »
Ymai
Tyrannosaurus Rex
Messages : 4220
Inscription : 12 mars 2005, 11:36

Message par Ymai »

Depuis le temps que j'attendais de pouvoir enfin publier moi aussi la fonction de Weierstrass!!!

Paré aux bugs, capitaine. Ils vont passer un mauvais quart d'heure.

Message envoyé avec : Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.9.0.4) Gecko/2008111317 Ubuntu/8.04 (hardy) Firefox/3.0.4
ymai
« Un enfant de cinq ans comprendrait cela ! Allez me chercher un enfant de cinq ans ! »
Groucho Marx.
Verrouillé

Qui est en ligne ?

Utilisateurs parcourant ce forum : Google [Bot] et 4 invités